#ifndef PIG_EXTERN_C
#ifdef __cplusplus
#define PIG_EXTERN_C extern "C"
#else
#define PIG_EXTERN_C
#endif
#endif
#ifndef NDEBUG
#   define NDEBUG
#   define NDEBUG_WAS_NOT_DEFINED
#endif

#include "syntree.h"

#include <config.h>
#include <rose.h>

#include "pignodelist.h"

PIG_EXTERN_C Expression Statement_ExprStatement_get_expression(Statement NODE){ return (void *) isSgExprStatement((SgNode *) NODE)->get_expression();}
PIG_EXTERN_C int is_op_Statement_ExprStatement(Statement NODE){ return isSgExprStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_LabelStatement(Statement NODE){ return isSgLabelStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Statement_CaseOptionStmt_get_key(Statement NODE){ return (void *) isSgCaseOptionStmt((SgNode *) NODE)->get_key();}
PIG_EXTERN_C int is_op_Statement_CaseOptionStmt(Statement NODE){ return isSgCaseOptionStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_DefaultOptionStmt(Statement NODE){ return isSgDefaultOptionStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_BreakStmt(Statement NODE){ return isSgBreakStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_ContinueStmt(Statement NODE){ return isSgContinueStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Statement_ReturnStmt_get_expression(Statement NODE){ return (void *) isSgReturnStmt((SgNode *) NODE)->get_expression();}
PIG_EXTERN_C int is_op_Statement_ReturnStmt(Statement NODE){ return isSgReturnStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_GotoStatement(Statement NODE){ return isSgGotoStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Statement Statement_ForInitStatement_get_init_stmt(Statement NODE){ return (void *) new PigNodeList( isSgForInitStatement((SgNode *) NODE)->get_init_stmt());}
PIG_EXTERN_C int is_op_Statement_ForInitStatement(Statement NODE){ return isSgForInitStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int LIST_Statement_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_Statement_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_Statement_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C int is_op_Statement_ClinkageStartStatement(Statement NODE){ return isSgClinkageStartStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_DeclarationStatement(Statement NODE){ return isSgDeclarationStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ScopeStatementNT Statement_ScopeStatement_get_node(Statement NODE){ return NODE;}
PIG_EXTERN_C int is_op_Statement_ScopeStatement(Statement NODE){ return isSgScopeStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Statement_NullStatement(Statement NODE){ return isSgNullStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C VariableSymbolNT Statement_DeclareStmt_get_var(Statement NODE){ DeclareStmt *stmt = dynamic_cast<DeclareStmt *>((SgNode *) NODE); return (void *) stmt->get_var();}
PIG_EXTERN_C int is_op_Statement_DeclareStmt(Statement NODE){ return dynamic_cast<DeclareStmt *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C Type Statement_DeclareStmt_get_type(Statement NODE){ DeclareStmt *stmt = dynamic_cast<DeclareStmt *>((SgNode *) NODE); return (void *) stmt->get_type();}
PIG_EXTERN_C VariableSymbolNT Statement_UndeclareStmt_get_vars(Statement NODE){ return new PigNodeList(*((UndeclareStmt *) NODE)->get_vars());}
PIG_EXTERN_C int is_op_Statement_UndeclareStmt(Statement NODE){ return dynamic_cast<UndeclareStmt *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C int LIST_VariableSymbolNT_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_VariableSymbolNT_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_VariableSymbolNT_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C Expression Statement_ExternalCall_get_function(Statement NODE){ ExternalCall *stmt = dynamic_cast<ExternalCall *>((SgNode *) NODE); return stmt->get_function();}
PIG_EXTERN_C int is_op_Statement_ExternalCall(Statement NODE){ ExternalCall *e = dynamic_cast<ExternalCall *>(isSgStatement((SgNode *) NODE)); return e != NULL;}
PIG_EXTERN_C VariableSymbolNT Statement_ExternalCall_get_params(Statement NODE){ ExternalCall *stmt = dynamic_cast<ExternalCall *>((SgNode *) NODE); return new PigNodeList(*stmt->get_params());}
PIG_EXTERN_C Type Statement_ExternalCall_get_type(Statement NODE){ ExternalCall *stmt = dynamic_cast<ExternalCall *>((SgNode *) NODE); return stmt->get_type();}
PIG_EXTERN_C aststring Statement_ConstructorCall_get_name(Statement NODE){ ConstructorCall *stmt = dynamic_cast<ConstructorCall *>((SgNode *) NODE); return strdup(stmt->get_name());}
PIG_EXTERN_C int is_op_Statement_ConstructorCall(Statement NODE){ ConstructorCall *e = dynamic_cast<ConstructorCall *>(isSgStatement((SgNode *) NODE)); return e != NULL;}
PIG_EXTERN_C Type Statement_ConstructorCall_get_type(Statement NODE){ ConstructorCall *stmt = dynamic_cast<ConstructorCall *>((SgNode *) NODE); return stmt->get_type();}
PIG_EXTERN_C aststring Statement_DestructorCall_get_name(Statement NODE){ DestructorCall *stmt = dynamic_cast<DestructorCall *>((SgNode *) NODE); return strdup(stmt->get_name());}
PIG_EXTERN_C int is_op_Statement_DestructorCall(Statement NODE){ DestructorCall *e = dynamic_cast<DestructorCall *>(isSgStatement((SgNode *) NODE)); return e != NULL;}
PIG_EXTERN_C Type Statement_DestructorCall_get_type(Statement NODE){ DestructorCall *stmt = dynamic_cast<DestructorCall *>((SgNode *) NODE); return stmt->get_type();}
PIG_EXTERN_C Expression Statement_ArgumentAssignment_get_lhs(Statement NODE){ ArgumentAssignment *assignment = dynamic_cast<ArgumentAssignment *>((SgNode *) NODE); return assignment->get_lhs();}
PIG_EXTERN_C int is_op_Statement_ArgumentAssignment(Statement NODE){ return dynamic_cast<ArgumentAssignment *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C Expression Statement_ArgumentAssignment_get_rhs(Statement NODE){ ArgumentAssignment *assignment = dynamic_cast<ArgumentAssignment *>((SgNode *) NODE); return assignment->get_rhs();}
PIG_EXTERN_C VariableSymbolNT Statement_ReturnAssignment_get_lhs(Statement NODE){ ReturnAssignment *assignment = dynamic_cast<ReturnAssignment *>((SgNode *) NODE); return assignment->get_lhs();}
PIG_EXTERN_C int is_op_Statement_ReturnAssignment(Statement NODE){ return dynamic_cast<ReturnAssignment *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C VariableSymbolNT Statement_ReturnAssignment_get_rhs(Statement NODE){ ReturnAssignment *assignment = dynamic_cast<ReturnAssignment *>((SgNode *) NODE); return assignment->get_rhs();}
PIG_EXTERN_C VariableSymbolNT Statement_ParamAssignment_get_lhs(Statement NODE){ ParamAssignment *assignment = dynamic_cast<ParamAssignment *>((SgNode *) NODE); return assignment->get_lhs();}
PIG_EXTERN_C int is_op_Statement_ParamAssignment(Statement NODE){ return dynamic_cast<ParamAssignment *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C VariableSymbolNT Statement_ParamAssignment_get_rhs(Statement NODE){ ParamAssignment *assignment = dynamic_cast<ParamAssignment *>((SgNode *) NODE); return assignment->get_rhs();}
PIG_EXTERN_C Expression Statement_LogicalIf_get_condition(Statement NODE){ LogicalIf *assignment = dynamic_cast<LogicalIf *>((SgNode *) NODE); return assignment->get_condition();}
PIG_EXTERN_C int is_op_Statement_LogicalIf(Statement NODE){ return dynamic_cast<LogicalIf *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C int is_op_Statement_IfJoin(Statement NODE){ return dynamic_cast<IfJoin *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C int is_op_Statement_WhileJoin(Statement NODE){ return dynamic_cast<WhileJoin *>(isSgStatement((SgNode *) NODE)) != NULL;}
PIG_EXTERN_C aststring Statement_FunctionEntry_get_funcname(Statement NODE){ FunctionEntry *stmt = dynamic_cast<FunctionEntry *>((SgNode *) NODE); return strdup(stmt->get_funcname());}
PIG_EXTERN_C int is_op_Statement_FunctionEntry(Statement NODE){ FunctionEntry *e = dynamic_cast<FunctionEntry *>(isSgStatement((SgNode *) NODE)); return e != NULL && e->parent != NULL && e->parent->node_type == (KFG_NODE_TYPE) X_FunctionEntry;}
PIG_EXTERN_C aststring Statement_FunctionExit_get_funcname(Statement NODE){ FunctionExit *stmt = dynamic_cast<FunctionExit *>((SgNode *) NODE); return strdup(stmt->get_funcname());}
PIG_EXTERN_C int is_op_Statement_FunctionExit(Statement NODE){ FunctionExit *e = dynamic_cast<FunctionExit *>(isSgStatement((SgNode *) NODE)); return e != NULL && e->parent != NULL && e->parent->node_type == (KFG_NODE_TYPE) X_FunctionExit;}
PIG_EXTERN_C VariableSymbolNT Statement_FunctionExit_get_params(Statement NODE){ if (((CallStmt *) NODE)->parent->paramlist != NULL) return new PigNodeList(*((CallStmt *) NODE)->parent->paramlist); else return NULL;}
PIG_EXTERN_C aststring Statement_FunctionCall_get_funcname(Statement NODE){ FunctionCall *stmt = dynamic_cast<FunctionCall *>((SgNode *) NODE); return strdup(stmt->get_funcname());}
PIG_EXTERN_C int is_op_Statement_FunctionCall(Statement NODE){ FunctionCall *e = dynamic_cast<FunctionCall *>(isSgStatement((SgNode *) NODE)); return e != NULL && e->parent != NULL && e->parent->node_type == (KFG_NODE_TYPE) X_FunctionCall;}
PIG_EXTERN_C VariableSymbolNT Statement_FunctionCall_get_params(Statement NODE){ if (((CallStmt *) NODE)->parent->paramlist != NULL) return new PigNodeList(*((CallStmt *) NODE)->parent->paramlist); else return NULL;}
PIG_EXTERN_C aststring Statement_FunctionReturn_get_funcname(Statement NODE){ FunctionReturn *stmt = dynamic_cast<FunctionReturn *>((SgNode *) NODE); return strdup(stmt->get_funcname());}
PIG_EXTERN_C int is_op_Statement_FunctionReturn(Statement NODE){ FunctionReturn *e = dynamic_cast<FunctionReturn *>(isSgStatement((SgNode *) NODE)); return e != NULL && e->parent != NULL && e->parent->node_type == (KFG_NODE_TYPE) X_FunctionReturn;}
PIG_EXTERN_C VariableSymbolNT Statement_FunctionReturn_get_params(Statement NODE){ if (((CallStmt *) NODE)->parent->paramlist != NULL) return new PigNodeList(*((CallStmt *) NODE)->parent->paramlist); else return NULL;}
PIG_EXTERN_C InitializedNameNT DeclarationStatement_VariableDeclaration_get_variables(DeclarationStatement NODE){ return (void *) new PigNodeList( isSgVariableDeclaration((SgNode *) NODE)->get_variables());}
PIG_EXTERN_C int is_op_DeclarationStatement_VariableDeclaration(DeclarationStatement NODE){ return isSgVariableDeclaration((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int LIST_InitializedNameNT_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_InitializedNameNT_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_InitializedNameNT_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C InitializedNameNT DeclarationStatement_VariableDefinition_get_vardefn(DeclarationStatement NODE){ return (void *) isSgVariableDefinition((SgNode *) NODE)->get_vardefn();}
PIG_EXTERN_C int is_op_DeclarationStatement_VariableDefinition(DeclarationStatement NODE){ return isSgVariableDefinition((SgNode *) NODE) != NULL;}
PIG_EXTERN_C UnsignedLongValNT DeclarationStatement_VariableDefinition_get_bitfield(DeclarationStatement NODE){ return (void *) isSgVariableDefinition((SgNode *) NODE)->get_bitfield();}
PIG_EXTERN_C int is_op_DeclarationStatement_EnumDeclaration(DeclarationStatement NODE){ return isSgEnumDeclaration((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression DeclarationStatement_AsmStmt_get_operands(DeclarationStatement NODE){ return (void *) new PigNodeList( isSgAsmStmt((SgNode *) NODE)->get_operands());}
PIG_EXTERN_C int is_op_DeclarationStatement_AsmStmt(DeclarationStatement NODE){ return isSgAsmStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int LIST_Expression_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_Expression_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_Expression_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C NamespaceDefinitionStatementNT DeclarationStatement_NamespaceDeclarationStatement_get_definition(DeclarationStatement NODE){ return (void *) isSgNamespaceDeclarationStatement((SgNode *) NODE)->get_definition();}
PIG_EXTERN_C int is_op_DeclarationStatement_NamespaceDeclarationStatement(DeclarationStatement NODE){ return isSgNamespaceDeclarationStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_DeclarationStatement_NamespaceAliasDeclarationStatement(DeclarationStatement NODE){ return isSgNamespaceAliasDeclarationStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_DeclarationStatement_UsingDirectiveStatement(DeclarationStatement NODE){ return isSgUsingDirectiveStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_DeclarationStatement_UsingDeclarationStatement(DeclarationStatement NODE){ return isSgUsingDeclarationStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C InitializedNameNT DeclarationStatement_FunctionParameterList_get_args(DeclarationStatement NODE){ return (void *) new PigNodeList( isSgFunctionParameterList((SgNode *) NODE)->get_args());}
PIG_EXTERN_C int is_op_DeclarationStatement_FunctionParameterList(DeclarationStatement NODE){ return isSgFunctionParameterList((SgNode *) NODE) != NULL;}
PIG_EXTERN_C InitializedNameNT DeclarationStatement_CtorInitializerList_get_ctors(DeclarationStatement NODE){ return (void *) new PigNodeList( isSgCtorInitializerList((SgNode *) NODE)->get_ctors());}
PIG_EXTERN_C int is_op_DeclarationStatement_CtorInitializerList(DeclarationStatement NODE){ return isSgCtorInitializerList((SgNode *) NODE) != NULL;}
PIG_EXTERN_C PragmaNT DeclarationStatement_PragmaDeclaration_get_pragma(DeclarationStatement NODE){ return (void *) isSgPragmaDeclaration((SgNode *) NODE)->get_pragma();}
PIG_EXTERN_C int is_op_DeclarationStatement_PragmaDeclaration(DeclarationStatement NODE){ return isSgPragmaDeclaration((SgNode *) NODE) != NULL;}
PIG_EXTERN_C DeclarationStatement ScopeStatementNT_Global_get_declarations(ScopeStatementNT NODE){ return (void *) new PigNodeList( isSgGlobal((SgNode *) NODE)->get_declarations());}
PIG_EXTERN_C int is_op_ScopeStatementNT_Global(ScopeStatementNT NODE){ return isSgGlobal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int LIST_DeclarationStatement_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_DeclarationStatement_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_DeclarationStatement_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C Statement ScopeStatementNT_IfStmt_get_conditional(ScopeStatementNT NODE){ return (void *) isSgIfStmt((SgNode *) NODE)->get_conditional();}
PIG_EXTERN_C int is_op_ScopeStatementNT_IfStmt(ScopeStatementNT NODE){ return isSgIfStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ForInitStatementNT ScopeStatementNT_ForStatement_get_for_init_stmt(ScopeStatementNT NODE){ return (void *) isSgForStatement((SgNode *) NODE)->get_for_init_stmt();}
PIG_EXTERN_C int is_op_ScopeStatementNT_ForStatement(ScopeStatementNT NODE){ return isSgForStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression ScopeStatementNT_ForStatement_get_test(ScopeStatementNT NODE){ return (void *) isSgForStatement((SgNode *) NODE)->get_test();}
PIG_EXTERN_C Expression ScopeStatementNT_ForStatement_get_increment(ScopeStatementNT NODE){ return (void *) isSgForStatement((SgNode *) NODE)->get_increment();}
PIG_EXTERN_C int is_op_ScopeStatementNT_FunctionDefinition(ScopeStatementNT NODE){ return isSgFunctionDefinition((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Statement ScopeStatementNT_WhileStmt_get_condition(ScopeStatementNT NODE){ return (void *) isSgWhileStmt((SgNode *) NODE)->get_condition();}
PIG_EXTERN_C int is_op_ScopeStatementNT_WhileStmt(ScopeStatementNT NODE){ return isSgWhileStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Statement ScopeStatementNT_DoWhileStmt_get_condition(ScopeStatementNT NODE){ return (void *) isSgDoWhileStmt((SgNode *) NODE)->get_condition();}
PIG_EXTERN_C int is_op_ScopeStatementNT_DoWhileStmt(ScopeStatementNT NODE){ return isSgDoWhileStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Statement ScopeStatementNT_SwitchStatement_get_item_selector(ScopeStatementNT NODE){ return (void *) isSgSwitchStatement((SgNode *) NODE)->get_item_selector();}
PIG_EXTERN_C int is_op_ScopeStatementNT_SwitchStatement(ScopeStatementNT NODE){ return isSgSwitchStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C VariableDeclarationNT ScopeStatementNT_CatchOptionStmt_get_condition(ScopeStatementNT NODE){ return (void *) isSgCatchOptionStmt((SgNode *) NODE)->get_condition();}
PIG_EXTERN_C int is_op_ScopeStatementNT_CatchOptionStmt(ScopeStatementNT NODE){ return isSgCatchOptionStmt((SgNode *) NODE) != NULL;}
PIG_EXTERN_C DeclarationStatement ScopeStatementNT_NamespaceDefinitionStatement_get_declarations(ScopeStatementNT NODE){ return (void *) new PigNodeList( isSgNamespaceDefinitionStatement((SgNode *) NODE)->get_declarations());}
PIG_EXTERN_C int is_op_ScopeStatementNT_NamespaceDefinitionStatement(ScopeStatementNT NODE){ return isSgNamespaceDefinitionStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C aststring Expression_VarRefExp_get_name(Expression NODE){ SgInitializedName *in = isSgInitializedName((SgNode *) NODE); if (in == NULL && isSgVarRefExp((SgNode *) NODE)) in = isSgVarRefExp((SgNode *) NODE)->get_symbol()->get_declaration(); if (in != NULL) { if ((in->get_scope() != NULL) && (in->get_scope()->get_qualified_name()!="::")) { return strdup(in->get_qualified_name().str()); } else { return strdup(in->get_name().str()); } } else return NULL;}
PIG_EXTERN_C int is_op_Expression_VarRefExp(Expression NODE){ return isSgVarRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Expression_ClassNameRefExp(Expression NODE){ return isSgClassNameRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Expression_FunctionRefExp(Expression NODE){ return isSgFunctionRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Expression_MemberFunctionRefExp(Expression NODE){ return isSgMemberFunctionRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_FunctionCallExp_get_function(Expression NODE){ return (void *) isSgFunctionCallExp((SgNode *) NODE)->get_function();}
PIG_EXTERN_C int is_op_Expression_FunctionCallExp(Expression NODE){ return isSgFunctionCallExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ExprListExpNT Expression_FunctionCallExp_get_args(Expression NODE){ return (void *) new PigNodeList( isSgFunctionCallExp((SgNode *) NODE)->get_args());}
PIG_EXTERN_C Expression Expression_SizeOfOp_get_operand_expr(Expression NODE){ return (void *) isSgSizeOfOp((SgNode *) NODE)->get_operand_expr();}
PIG_EXTERN_C int is_op_Expression_SizeOfOp(Expression NODE){ return isSgSizeOfOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ConditionalExp_get_conditional_exp(Expression NODE){ return (void *) isSgConditionalExp((SgNode *) NODE)->get_conditional_exp();}
PIG_EXTERN_C int is_op_Expression_ConditionalExp(Expression NODE){ return isSgConditionalExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ConditionalExp_get_true_exp(Expression NODE){ return (void *) isSgConditionalExp((SgNode *) NODE)->get_true_exp();}
PIG_EXTERN_C Expression Expression_ConditionalExp_get_false_exp(Expression NODE){ return (void *) isSgConditionalExp((SgNode *) NODE)->get_false_exp();}
PIG_EXTERN_C ExprListExpNT Expression_NewExp_get_placement_args(Expression NODE){ return (void *) isSgNewExp((SgNode *) NODE)->get_placement_args();}
PIG_EXTERN_C int is_op_Expression_NewExp(Expression NODE){ return isSgNewExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ConstructorInitializerNT Expression_NewExp_get_constructor_args(Expression NODE){ return (void *) isSgNewExp((SgNode *) NODE)->get_constructor_args();}
PIG_EXTERN_C Expression Expression_NewExp_get_builtin_args(Expression NODE){ return (void *) isSgNewExp((SgNode *) NODE)->get_builtin_args();}
PIG_EXTERN_C Expression Expression_DeleteExp_get_variable(Expression NODE){ return (void *) isSgDeleteExp((SgNode *) NODE)->get_variable();}
PIG_EXTERN_C int is_op_Expression_DeleteExp(Expression NODE){ return isSgDeleteExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Expression_ThisExp_get_type(Expression NODE){ return (void *) isSgThisExp((SgNode *) NODE)->get_type();}
PIG_EXTERN_C int is_op_Expression_ThisExp(Expression NODE){ return isSgThisExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_Expression_RefExp(Expression NODE){ return isSgRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_VarArgStartOp_get_lhs_operand(Expression NODE){ return (void *) isSgVarArgStartOp((SgNode *) NODE)->get_lhs_operand();}
PIG_EXTERN_C int is_op_Expression_VarArgStartOp(Expression NODE){ return isSgVarArgStartOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_VarArgStartOp_get_rhs_operand(Expression NODE){ return (void *) isSgVarArgStartOp((SgNode *) NODE)->get_rhs_operand();}
PIG_EXTERN_C Expression Expression_VarArgOp_get_operand_expr(Expression NODE){ return (void *) isSgVarArgOp((SgNode *) NODE)->get_operand_expr();}
PIG_EXTERN_C int is_op_Expression_VarArgOp(Expression NODE){ return isSgVarArgOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_VarArgEndOp_get_operand_expr(Expression NODE){ return (void *) isSgVarArgEndOp((SgNode *) NODE)->get_operand_expr();}
PIG_EXTERN_C int is_op_Expression_VarArgEndOp(Expression NODE){ return isSgVarArgEndOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_VarArgCopyOp_get_lhs_operand(Expression NODE){ return (void *) isSgVarArgCopyOp((SgNode *) NODE)->get_lhs_operand();}
PIG_EXTERN_C int is_op_Expression_VarArgCopyOp(Expression NODE){ return isSgVarArgCopyOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_VarArgCopyOp_get_rhs_operand(Expression NODE){ return (void *) isSgVarArgCopyOp((SgNode *) NODE)->get_rhs_operand();}
PIG_EXTERN_C Expression Expression_VarArgStartOneOperandOp_get_operand_expr(Expression NODE){ return (void *) isSgVarArgStartOneOperandOp((SgNode *) NODE)->get_operand_expr();}
PIG_EXTERN_C int is_op_Expression_VarArgStartOneOperandOp(Expression NODE){ return isSgVarArgStartOneOperandOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ExprListExpNT Expression_AggregateInitializer_get_initializers(Expression NODE){ return (void *) isSgAggregateInitializer((SgNode *) NODE)->get_initializers();}
PIG_EXTERN_C int is_op_Expression_AggregateInitializer(Expression NODE){ return isSgAggregateInitializer((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AssignInitializer_get_operand_i(Expression NODE){ return (void *) isSgAssignInitializer((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_AssignInitializer(Expression NODE){ return isSgAssignInitializer((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astint Expression_BoolValExp_get_value(Expression NODE){ return isSgBoolValExp((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_BoolValExp(Expression NODE){ return isSgBoolValExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C aststring Expression_StringVal_get_value(Expression NODE){ return strdup(isSgStringVal((SgNode *) NODE)->get_value().c_str());}
PIG_EXTERN_C int is_op_Expression_StringVal(Expression NODE){ return isSgStringVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astshort Expression_ShortVal_get_value(Expression NODE){ return isSgShortVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_ShortVal(Expression NODE){ return isSgShortVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astchar Expression_CharVal_get_value(Expression NODE){ return isSgCharVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_CharVal(Expression NODE){ return isSgCharVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astuchar Expression_UnsignedCharVal_get_value(Expression NODE){ return isSgUnsignedCharVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_UnsignedCharVal(Expression NODE){ return isSgUnsignedCharVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astulong Expression_WcharVal_get_value(Expression NODE){ return isSgWcharVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_WcharVal(Expression NODE){ return isSgWcharVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astushort Expression_UnsignedShortVal_get_value(Expression NODE){ return isSgUnsignedShortVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_UnsignedShortVal(Expression NODE){ return isSgUnsignedShortVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astint Expression_IntVal_get_value(Expression NODE){ return isSgIntVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_IntVal(Expression NODE){ return isSgIntVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astint Expression_EnumVal_get_value(Expression NODE){ return isSgEnumVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_EnumVal(Expression NODE){ return isSgEnumVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astuint Expression_UnsignedIntVal_get_value(Expression NODE){ return isSgUnsignedIntVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_UnsignedIntVal(Expression NODE){ return isSgUnsignedIntVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astlong Expression_LongIntVal_get_value(Expression NODE){ return isSgLongIntVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_LongIntVal(Expression NODE){ return isSgLongIntVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astllong Expression_LongLongIntVal_get_value(Expression NODE){ return isSgLongLongIntVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_LongLongIntVal(Expression NODE){ return isSgLongLongIntVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astullong Expression_UnsignedLongLongIntVal_get_value(Expression NODE){ return isSgUnsignedLongLongIntVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_UnsignedLongLongIntVal(Expression NODE){ return isSgUnsignedLongLongIntVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astulong Expression_UnsignedLongVal_get_value(Expression NODE){ return isSgUnsignedLongVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_UnsignedLongVal(Expression NODE){ return isSgUnsignedLongVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astfloat Expression_FloatVal_get_value(Expression NODE){ return isSgFloatVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_FloatVal(Expression NODE){ return isSgFloatVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astdouble Expression_DoubleVal_get_value(Expression NODE){ return isSgDoubleVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_DoubleVal(Expression NODE){ return isSgDoubleVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C astldouble Expression_LongDoubleVal_get_value(Expression NODE){ return isSgLongDoubleVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_Expression_LongDoubleVal(Expression NODE){ return isSgLongDoubleVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ArrowExp_get_lhs_operand_i(Expression NODE){ return (void *) isSgArrowExp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_ArrowExp(Expression NODE){ return isSgArrowExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ArrowExp_get_rhs_operand_i(Expression NODE){ return (void *) isSgArrowExp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_DotExp_get_lhs_operand_i(Expression NODE){ return (void *) isSgDotExp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_DotExp(Expression NODE){ return isSgDotExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_DotExp_get_rhs_operand_i(Expression NODE){ return (void *) isSgDotExp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_DotStarOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgDotStarOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_DotStarOp(Expression NODE){ return isSgDotStarOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_DotStarOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgDotStarOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_ArrowStarOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgArrowStarOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_ArrowStarOp(Expression NODE){ return isSgArrowStarOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ArrowStarOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgArrowStarOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_EqualityOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgEqualityOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_EqualityOp(Expression NODE){ return isSgEqualityOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_EqualityOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgEqualityOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_LessThanOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgLessThanOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_LessThanOp(Expression NODE){ return isSgLessThanOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_LessThanOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgLessThanOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_GreaterThanOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgGreaterThanOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_GreaterThanOp(Expression NODE){ return isSgGreaterThanOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_GreaterThanOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgGreaterThanOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_NotEqualOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgNotEqualOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_NotEqualOp(Expression NODE){ return isSgNotEqualOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_NotEqualOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgNotEqualOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_LessOrEqualOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgLessOrEqualOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_LessOrEqualOp(Expression NODE){ return isSgLessOrEqualOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_LessOrEqualOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgLessOrEqualOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_GreaterOrEqualOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgGreaterOrEqualOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_GreaterOrEqualOp(Expression NODE){ return isSgGreaterOrEqualOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_GreaterOrEqualOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgGreaterOrEqualOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_AddOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgAddOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_AddOp(Expression NODE){ return isSgAddOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AddOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgAddOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_SubtractOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgSubtractOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_SubtractOp(Expression NODE){ return isSgSubtractOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_SubtractOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgSubtractOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_MultiplyOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgMultiplyOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_MultiplyOp(Expression NODE){ return isSgMultiplyOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_MultiplyOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgMultiplyOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_DivideOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgDivideOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_DivideOp(Expression NODE){ return isSgDivideOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_DivideOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgDivideOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_IntegerDivideOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgIntegerDivideOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_IntegerDivideOp(Expression NODE){ return isSgIntegerDivideOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_IntegerDivideOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgIntegerDivideOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_ModOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgModOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_ModOp(Expression NODE){ return isSgModOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ModOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgModOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_AndOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgAndOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_AndOp(Expression NODE){ return isSgAndOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AndOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgAndOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_OrOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgOrOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_OrOp(Expression NODE){ return isSgOrOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_OrOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgOrOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_BitXorOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgBitXorOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_BitXorOp(Expression NODE){ return isSgBitXorOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_BitXorOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgBitXorOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_BitAndOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgBitAndOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_BitAndOp(Expression NODE){ return isSgBitAndOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_BitAndOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgBitAndOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_BitOrOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgBitOrOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_BitOrOp(Expression NODE){ return isSgBitOrOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_BitOrOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgBitOrOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_CommaOpExp_get_lhs_operand_i(Expression NODE){ return (void *) isSgCommaOpExp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_CommaOpExp(Expression NODE){ return isSgCommaOpExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_CommaOpExp_get_rhs_operand_i(Expression NODE){ return (void *) isSgCommaOpExp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_LshiftOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgLshiftOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_LshiftOp(Expression NODE){ return isSgLshiftOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_LshiftOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgLshiftOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_RshiftOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgRshiftOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_RshiftOp(Expression NODE){ return isSgRshiftOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_RshiftOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgRshiftOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_PntrArrRefExp_get_lhs_operand_i(Expression NODE){ return (void *) isSgPntrArrRefExp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_PntrArrRefExp(Expression NODE){ return isSgPntrArrRefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_PntrArrRefExp_get_rhs_operand_i(Expression NODE){ return (void *) isSgPntrArrRefExp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_ScopeOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgScopeOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_ScopeOp(Expression NODE){ return isSgScopeOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ScopeOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgScopeOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_AssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_AssignOp(Expression NODE){ return isSgAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_PlusAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgPlusAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_PlusAssignOp(Expression NODE){ return isSgPlusAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_PlusAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgPlusAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_MinusAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgMinusAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_MinusAssignOp(Expression NODE){ return isSgMinusAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_MinusAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgMinusAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_AndAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgAndAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_AndAssignOp(Expression NODE){ return isSgAndAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AndAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgAndAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_IorAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgIorAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_IorAssignOp(Expression NODE){ return isSgIorAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_IorAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgIorAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_MultAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgMultAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_MultAssignOp(Expression NODE){ return isSgMultAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_MultAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgMultAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_DivAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgDivAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_DivAssignOp(Expression NODE){ return isSgDivAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_DivAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgDivAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_ModAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgModAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_ModAssignOp(Expression NODE){ return isSgModAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_ModAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgModAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_XorAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgXorAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_XorAssignOp(Expression NODE){ return isSgXorAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_XorAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgXorAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_LshiftAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgLshiftAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_LshiftAssignOp(Expression NODE){ return isSgLshiftAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_LshiftAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgLshiftAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_RshiftAssignOp_get_lhs_operand_i(Expression NODE){ return (void *) isSgRshiftAssignOp((SgNode *) NODE)->get_lhs_operand_i();}
PIG_EXTERN_C int is_op_Expression_RshiftAssignOp(Expression NODE){ return isSgRshiftAssignOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_RshiftAssignOp_get_rhs_operand_i(Expression NODE){ return (void *) isSgRshiftAssignOp((SgNode *) NODE)->get_rhs_operand_i();}
PIG_EXTERN_C Expression Expression_MinusOp_get_operand_i(Expression NODE){ return (void *) isSgMinusOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_MinusOp(Expression NODE){ return isSgMinusOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_UnaryAddOp_get_operand_i(Expression NODE){ return (void *) isSgUnaryAddOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_UnaryAddOp(Expression NODE){ return isSgUnaryAddOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_NotOp_get_operand_i(Expression NODE){ return (void *) isSgNotOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_NotOp(Expression NODE){ return isSgNotOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_PointerDerefExp_get_operand_i(Expression NODE){ return (void *) isSgPointerDerefExp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_PointerDerefExp(Expression NODE){ return isSgPointerDerefExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_AddressOfOp_get_operand_i(Expression NODE){ return (void *) isSgAddressOfOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_AddressOfOp(Expression NODE){ return isSgAddressOfOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_MinusMinusOp_get_operand_i(Expression NODE){ return (void *) isSgMinusMinusOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_MinusMinusOp(Expression NODE){ return isSgMinusMinusOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_PlusPlusOp_get_operand_i(Expression NODE){ return (void *) isSgPlusPlusOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_PlusPlusOp(Expression NODE){ return isSgPlusPlusOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_BitComplementOp_get_operand_i(Expression NODE){ return (void *) isSgBitComplementOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_BitComplementOp(Expression NODE){ return isSgBitComplementOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression Expression_CastExp_get_operand_i(Expression NODE){ return (void *) isSgCastExp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_CastExp(Expression NODE){ return isSgCastExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Expression_CastExp_get_type(Expression NODE){ return (void *) isSgCastExp((SgNode *) NODE)->get_type();}
PIG_EXTERN_C Expression Expression_ThrowOp_get_operand_i(Expression NODE){ return (void *) isSgThrowOp((SgNode *) NODE)->get_operand_i();}
PIG_EXTERN_C int is_op_Expression_ThrowOp(Expression NODE){ return isSgThrowOp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C aststring InitializedNameNT_InitializedName_get_name(InitializedNameNT NODE){ SgInitializedName *in = isSgInitializedName((SgNode *) NODE); if (in == NULL && isSgVarRefExp((SgNode *) NODE)) in = isSgVarRefExp((SgNode *) NODE)->get_symbol()->get_declaration(); if (in != NULL) { if ((in->get_scope() != NULL) && (in->get_scope()->get_qualified_name()!="::")) { return strdup(in->get_qualified_name().str()); } else { return strdup(in->get_name().str()); } } else return NULL;}
PIG_EXTERN_C int is_op_InitializedNameNT_InitializedName(InitializedNameNT NODE){ return isSgInitializedName((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression InitializedNameNT_InitializedName_get_initptr(InitializedNameNT NODE){ return (void *) isSgInitializedName((SgNode *) NODE)->get_initptr();}
PIG_EXTERN_C astulong UnsignedLongValNT_UnsignedLongVal_get_value(UnsignedLongValNT NODE){ return isSgUnsignedLongVal((SgNode *) NODE)->get_value();}
PIG_EXTERN_C int is_op_UnsignedLongValNT_UnsignedLongVal(UnsignedLongValNT NODE){ return isSgUnsignedLongVal((SgNode *) NODE) != NULL;}
PIG_EXTERN_C DeclarationStatement NamespaceDefinitionStatementNT_NamespaceDefinitionStatement_get_declarations(NamespaceDefinitionStatementNT NODE){ return (void *) new PigNodeList( isSgNamespaceDefinitionStatement((SgNode *) NODE)->get_declarations());}
PIG_EXTERN_C int is_op_NamespaceDefinitionStatementNT_NamespaceDefinitionStatement(NamespaceDefinitionStatementNT NODE){ return isSgNamespaceDefinitionStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C int is_op_PragmaNT_Pragma(PragmaNT NODE){ return isSgPragma((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Statement ForInitStatementNT_ForInitStatement_get_init_stmt(ForInitStatementNT NODE){ return (void *) new PigNodeList( isSgForInitStatement((SgNode *) NODE)->get_init_stmt());}
PIG_EXTERN_C int is_op_ForInitStatementNT_ForInitStatement(ForInitStatementNT NODE){ return isSgForInitStatement((SgNode *) NODE) != NULL;}
PIG_EXTERN_C InitializedNameNT VariableDeclarationNT_VariableDeclaration_get_variables(VariableDeclarationNT NODE){ return (void *) new PigNodeList( isSgVariableDeclaration((SgNode *) NODE)->get_variables());}
PIG_EXTERN_C int is_op_VariableDeclarationNT_VariableDeclaration(VariableDeclarationNT NODE){ return isSgVariableDeclaration((SgNode *) NODE) != NULL;}
PIG_EXTERN_C aststring VariableSymbolNT_VariableSymbol_get_name(VariableSymbolNT NODE){ SgVariableSymbol *var = isSgVariableSymbol((SgNode *) NODE); if ((var->get_declaration()->get_scope() != NULL) && (var->get_declaration()->get_scope()->get_qualified_name() != "::") ) return strdup(var->get_declaration()->get_qualified_name().str()); else return strdup(var->get_declaration()->get_name().str());}
PIG_EXTERN_C int is_op_VariableSymbolNT_VariableSymbol(VariableSymbolNT NODE){ return isSgVariableSymbol((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Expression ExprListExpNT_ExprListExp_get_expressions(ExprListExpNT NODE){ return (void *) new PigNodeList( isSgExprListExp((SgNode *) NODE)->get_expressions());}
PIG_EXTERN_C int is_op_ExprListExpNT_ExprListExp(ExprListExpNT NODE){ return isSgExprListExp((SgNode *) NODE) != NULL;}
PIG_EXTERN_C ExprListExpNT ConstructorInitializerNT_ConstructorInitializer_get_args(ConstructorInitializerNT NODE){ return (void *) new PigNodeList( isSgConstructorInitializer((SgNode *) NODE)->get_args());}
PIG_EXTERN_C int is_op_ConstructorInitializerNT_ConstructorInitializer(ConstructorInitializerNT NODE){ return isSgConstructorInitializer((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Type_ArrayType_get_base_type(Type NODE){ return (void *) isSgArrayType((SgNode *) NODE)->get_base_type();}
PIG_EXTERN_C int is_op_Type_ArrayType(Type NODE){ return isSgArrayType((SgNode *) NODE) != NULL;}
PIG_EXTERN_C aststring Type_BasicType_get_typename(Type NODE){ return basic_type_name(NODE);}
PIG_EXTERN_C int is_op_Type_BasicType(Type NODE){ return basic_type_name(NODE) != NULL;}
PIG_EXTERN_C Type Type_FunctionType_get_return_type(Type NODE){ return (void *) isSgFunctionType((SgNode *) NODE)->get_return_type();}
PIG_EXTERN_C int is_op_Type_FunctionType(Type NODE){ return isSgFunctionType((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Type_FunctionType_get_arguments(Type NODE){ return (void *) new PigNodeList( isSgFunctionType((SgNode *) NODE)->get_arguments());}
PIG_EXTERN_C int LIST_Type_empty(void *NODE){ return ((PigNodeList *) NODE)->empty();}
PIG_EXTERN_C void *LIST_Type_hd(void *NODE){ return ((PigNodeList *) NODE)->head();}
PIG_EXTERN_C void *LIST_Type_tl(void *NODE){ return ((PigNodeList *) NODE)->tail();}
PIG_EXTERN_C aststring Type_NamedType_get_name(Type NODE){ SgNamedType *type = isSgNamedType((SgNode *) NODE); return strdup(type->get_name().str());}
PIG_EXTERN_C int is_op_Type_NamedType(Type NODE){ return isSgNamedType((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Type_PointerType_get_base_type(Type NODE){ return (void *) isSgPointerType((SgNode *) NODE)->get_base_type();}
PIG_EXTERN_C int is_op_Type_PointerType(Type NODE){ return isSgPointerType((SgNode *) NODE) != NULL;}
PIG_EXTERN_C Type Type_ReferenceType_get_base_type(Type NODE){ return (void *) isSgReferenceType((SgNode *) NODE)->get_base_type();}
PIG_EXTERN_C int is_op_Type_ReferenceType(Type NODE){ return isSgReferenceType((SgNode *) NODE) != NULL;}

//#include "pag_support.c"

#ifdef NDEBUG_WAS_NOT_DEFINED
#   undef NDEBUG
#endif
